obs = obslua

-- Define your API details
local apiKey = '69181ab22c2fe764:989832ed75fb775c278cffdad3d807c9'  -- Your API key
local stationId = '1'  -- Your station ID
local baseUrl = 'https://radio.soundcheckradio.net:8888'  -- Your AzuraCast base URL

-- Define variables for input fields
title = ""
artist = ""

-- Function to update metadata
function update_metadata()
    -- Make sure title and artist fields are filled
    if title ~= "" and artist ~= "" then
        -- Construct the curl command with correct escape sequences
        local curl_cmd = 'curl -s -X POST -H "Content-Type: application/json" -H "X-API-Key: ' .. apiKey .. '" -d "{\\"title\\": \\"' .. title .. '\\", \\"artist\\": \\"' .. artist .. '\\"}" "' .. baseUrl .. '/api/station/' .. stationId .. '/nowplaying/update"'

        -- Execute the curl command
        local result = io.popen(curl_cmd):read("*a")
        
        -- Print the result from the curl command (to be checked in the log)
        print("Curl command result: " .. result)
    else
        print("Error: Title or Artist field is empty!")
    end
end

-- Create the input fields in the script's settings panel
function script_properties()
    local props = obs.obs_properties_create()

    	  -- Artist input field
    obs.obs_properties_add_text(props, "artist_field", "DJ name", obs.OBS_TEXT_DEFAULT)


    -- Title input field
    obs.obs_properties_add_text(props, "title_field", "Show name", obs.OBS_TEXT_DEFAULT)

  

    -- Button to trigger metadata update (for manual use)
    obs.obs_properties_add_button(props, "update_button", "Update Metadata", update_metadata)

    return props
end

-- Function to handle input field changes
function script_update(settings)
    title = obs.obs_data_get_string(settings, "title_field")
    artist = obs.obs_data_get_string(settings, "artist_field")
end

-- Handle frontend events (like recording start/stop)
function on_event(pressed_event)
    if pressed_event == obs.OBS_FRONTEND_EVENT_RECORDING_STARTED then
        -- Trigger metadata update when recording starts
        update_metadata()
    end
end

-- Function to initialize event listeners
function script_load(settings)
    -- Listen to the event when recording starts
    obs.obs_frontend_add_event_callback(on_event)
end

function script_description()
    return "This script updates the stream metadata when the record button is pressed, or manually with the 'Update Metadata' button."
end
