obs = obslua

-- Define your API details
local apiKey = '69181ab22c2fe764:989832ed75fb775c278cffdad3d807c9'  -- Your API key
local stationId = '1'  -- Your station ID
local baseUrl = 'https://radio.soundcheckradio.net:8888'  -- Your AzuraCast base URL

-- Define variables for input fields
title = ""
artist = ""

-- Function to update metadata
function update_metadata()
    -- Construct the curl command with correct escape sequences
    local curl_cmd = 'curl -s -X POST -H "Content-Type: application/json" -H "X-API-Key: ' .. apiKey .. '" -d "{\\"title\\": \\"' .. title .. '\\", \\"artist\\": \\"' .. artist .. '\\"}" "' .. baseUrl .. '/api/station/' .. stationId .. '/nowplaying/update"'

    -- Execute the curl command without opening a terminal window
    local result = io.popen(curl_cmd):read("*a")
    
  
    
    -- Simulate the error and log "Now Playing" 3 seconds after update
    obs.timer_add(simulate_error_and_log_now_playing, 3000)  -- Delay 3 seconds
end

-- Function to simulate an error and log the "Now Playing" message
function simulate_error_and_log_now_playing()
    -- Simulate an error to open the Script Console window
    obs.script_log(obs.LOG_ERROR, "Metadata updated to : " .. title .. " - " .. artist)
    
    -- Remove the timer to ensure it only runs once
    obs.timer_remove(simulate_error_and_log_now_playing)
end

-- Function to listen for recording events
function recording_event(pressed)
    if pressed then
        -- Record button pressed, trigger metadata update
        update_metadata()
    end
end

-- Add event callback to listen for recording events
function script_load(settings)
    obs.obs_frontend_add_event_callback(function(event)
        if event == obs.OBS_FRONTEND_EVENT_RECORDING_STARTED then
            recording_event(true)
        elseif event == obs.OBS_FRONTEND_EVENT_RECORDING_STOPPED then
            recording_event(false)
        end
    end)
end

-- Create the input fields in the script's settings panel
function script_properties()
    local props = obs.obs_properties_create()

	  -- Artist input field
    obs.obs_properties_add_text(props, "artist_field", "DJ name", obs.OBS_TEXT_DEFAULT)


    -- Title input field
    obs.obs_properties_add_text(props, "title_field", "Show name", obs.OBS_TEXT_DEFAULT)

  

    -- Button to trigger metadata update (for manual override)
    obs.obs_properties_add_button(props, "update_button", "Update Metadata", update_metadata)

    return props
end

-- Function to handle input field changes
function script_update(settings)
    title = obs.obs_data_get_string(settings, "title_field")
    artist = obs.obs_data_get_string(settings, "artist_field")
end

function script_description()
    return "This script updates metadata and shows 'Current titles' when the record button or update button is pressed."
end
